//////////////////////////////////////////////////////////////////////////////
//
// ***************************************************************************
// **                                                                       **
// ** Copyright (c) 1995-2004 Xilinx, Inc.  All rights reserved.            **
// **                                                                       **
// ** You may copy and modify these files for your own internal use solely  **
// ** with Xilinx programmable logic devices and Xilinx EDK system or       **
// ** create IP modules solely for Xilinx programmable logic devices and    **
// ** Xilinx EDK system. No rights are granted to distribute any files      **
// ** unless they are distributed in Xilinx programmable logic devices.     **
// **                                                                       **
// ***************************************************************************
//
//////////////////////////////////////////////////////////////////////////////
// Filename:          <path to project>\drivers\opb_LAregister_v2_00_a\src\opb_LAregister.c
// Version:           2.00.a
// Description:       opb_LAregister Driver Source File
// Date:              Sun Mar 20 12:29:52 2005 (by Create and Import Peripheral Wizard)
//////////////////////////////////////////////////////////////////////////////


/***************************** Include Files *******************************/

#include "opb_LAregister.h"

/************************** Function Definitions ***************************/

/**
 *
 * Example interrupt controller handler for OPB_LAREGISTER device.
 * This is to show example of how to toggle write back ISR to clear interrupts.
 *
 * @param   baseaddr_p is the base address of the OPB_LAREGISTER device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void OPB_LAREGISTER_Intr_DefaultHandler(void * baseaddr_p)
{
  Xuint32 baseaddr;
  Xuint32 IntrStatus;

  XASSERT_VOID(baseaddr_p != XNULL);

  baseaddr = (Xuint32) baseaddr_p;

  // get status from IP Interrupt Status Register
  IntrStatus = OPB_LAREGISTER_mReadReg(baseaddr, OPB_LAREGISTER_INTR_ISR_OFFSET);

  xil_printf("IP Interrupt! Status register value : 0x%x \n\r", IntrStatus);

  // toggle write back IP ISR to clear IP interrupts
  OPB_LAREGISTER_mWriteReg(baseaddr, OPB_LAREGISTER_INTR_ISR_OFFSET, IntrStatus);
}
