//////////////////////////////////////////////////////////////////////////////
//
// ***************************************************************************
// **                                                                       **
// ** Copyright (c) 1995-2004 Xilinx, Inc.  All rights reserved.            **
// **                                                                       **
// ** You may copy and modify these files for your own internal use solely  **
// ** with Xilinx programmable logic devices and Xilinx EDK system or       **
// ** create IP modules solely for Xilinx programmable logic devices and    **
// ** Xilinx EDK system. No rights are granted to distribute any files      **
// ** unless they are distributed in Xilinx programmable logic devices.     **
// **                                                                       **
// ***************************************************************************
//
//////////////////////////////////////////////////////////////////////////////
// Filename:          <path to project>\drivers\opb_LAregister_v2_00_a\src\opb_LAregister.h
// Version:           2.00.a
// Description:       opb_LAregister Driver Header File
// Date:              Sun Mar 20 12:29:52 2005 (by Create and Import Peripheral Wizard)
//////////////////////////////////////////////////////////////////////////////

#ifndef OPB_LAREGISTER_H
#define OPB_LAREGISTER_H

/***************************** Include Files *******************************/

#include "xbasic_types.h"
#include "xio.h"

/************************** Constant Definitions ***************************/

#define OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET (0x00000000)
#define OPB_LAREGISTER_SLAVE_REG0_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000000)
#define OPB_LAREGISTER_SLAVE_REG1_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000004)
#define OPB_LAREGISTER_SLAVE_REG2_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000008)
#define OPB_LAREGISTER_SLAVE_REG3_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x0000000C)
#define OPB_LAREGISTER_SLAVE_REG4_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000010)
#define OPB_LAREGISTER_SLAVE_REG5_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000014)
#define OPB_LAREGISTER_SLAVE_REG6_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000018)
#define OPB_LAREGISTER_SLAVE_REG7_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x0000001C)
#define OPB_LAREGISTER_SLAVE_REG8_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000020)
#define OPB_LAREGISTER_SLAVE_REG9_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000024)
#define OPB_LAREGISTER_SLAVE_REG10_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000028)
#define OPB_LAREGISTER_SLAVE_REG11_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x0000002C)
#define OPB_LAREGISTER_SLAVE_REG12_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000030)
#define OPB_LAREGISTER_SLAVE_REG13_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000034)
#define OPB_LAREGISTER_SLAVE_REG14_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000038)
#define OPB_LAREGISTER_SLAVE_REG15_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x0000003C)
#define OPB_LAREGISTER_SLAVE_REG16_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000040)
#define OPB_LAREGISTER_SLAVE_REG17_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000044)
#define OPB_LAREGISTER_SLAVE_REG18_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000048)
#define OPB_LAREGISTER_SLAVE_REG19_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x0000004C)
#define OPB_LAREGISTER_SLAVE_REG20_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000050)
#define OPB_LAREGISTER_SLAVE_REG21_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000054)
#define OPB_LAREGISTER_SLAVE_REG22_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000058)
#define OPB_LAREGISTER_SLAVE_REG23_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x0000005C)
#define OPB_LAREGISTER_SLAVE_REG24_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000060)
#define OPB_LAREGISTER_SLAVE_REG25_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000064)
#define OPB_LAREGISTER_SLAVE_REG26_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000068)
#define OPB_LAREGISTER_SLAVE_REG27_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x0000006C)
#define OPB_LAREGISTER_SLAVE_REG28_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000070)
#define OPB_LAREGISTER_SLAVE_REG29_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000074)
#define OPB_LAREGISTER_SLAVE_REG30_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x00000078)
#define OPB_LAREGISTER_SLAVE_REG31_OFFSET (OPB_LAREGISTER_USER_SLAVE_SPACE_OFFSET + 0x0000007C)

#define OPB_LAREGISTER_IPIF_RST_SPACE_OFFSET (0x00000100)
#define OPB_LAREGISTER_RESET_REG_OFFSET (OPB_LAREGISTER_IPIF_RST_SPACE_OFFSET + 0x00000000)
#define OPB_LAREGISTER_MIR_REG_OFFSET (OPB_LAREGISTER_IPIF_RST_SPACE_OFFSET + 0x00000000)

#define OPB_LAREGISTER_IPIF_INTR_SPACE_OFFSET (0x00000200)
#define OPB_LAREGISTER_INTR_DISR_OFFSET (OPB_LAREGISTER_IPIF_INTR_SPACE_OFFSET + 0x00000000)
#define OPB_LAREGISTER_INTR_DIPR_OFFSET (OPB_LAREGISTER_IPIF_INTR_SPACE_OFFSET + 0x00000004)
#define OPB_LAREGISTER_INTR_DIER_OFFSET (OPB_LAREGISTER_IPIF_INTR_SPACE_OFFSET + 0x00000008)
#define OPB_LAREGISTER_INTR_DIIR_OFFSET (OPB_LAREGISTER_IPIF_INTR_SPACE_OFFSET + 0x00000018)
#define OPB_LAREGISTER_INTR_DGIER_OFFSET (OPB_LAREGISTER_IPIF_INTR_SPACE_OFFSET + 0x0000001C)
#define OPB_LAREGISTER_INTR_ISR_OFFSET (OPB_LAREGISTER_IPIF_INTR_SPACE_OFFSET + 0x00000020)
#define OPB_LAREGISTER_INTR_IER_OFFSET (OPB_LAREGISTER_IPIF_INTR_SPACE_OFFSET + 0x00000028)


/***************** Macros (Inline Functions) Definitions *******************/

/**
 *
 * Write a value to a OPB_LAREGISTER register. A 32 bit write is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is written.
 *
 * @param   BaseAddress is the base address of the OPB_LAREGISTER device.
 * @param   RegOffset is the register offset from the base to write to.
 * @param   Data is the data written to the register.
 *
 * @return  None.
 *
 * @note    None.
 *
 * C-style signature:
 * 	void OPB_LAREGISTER_mWriteReg(Xuint32 BaseAddress, unsigned RegOffset, Xuint32 Data)
 *
 */
#define OPB_LAREGISTER_mWriteReg(BaseAddress, RegOffset, Data) \
 	XIo_Out32((BaseAddress) + (RegOffset), (Xuint32)(Data))

/**
 *
 * Read a value from a OPB_LAREGISTER register. A 32 bit read is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is read from the register. The most significant data
 * will be read as 0.
 *
 * @param   BaseAddress is the base address of the OPB_LAREGISTER device.
 * @param   RegOffset is the register offset from the base to write to.
 *
 * @return  Data is the data from the register.
 *
 * @note    None.
 *
 * C-style signature:
 * 	Xuint32 OPB_LAREGISTER_mReadReg(Xuint32 BaseAddress, unsigned RegOffset)
 *
 */
#define OPB_LAREGISTER_mReadReg(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (RegOffset))

/************************** Function Prototypes ****************************/

/**
 *
 * Example interrupt controller handler.
 *
 * @param   baseaddr_p is the base address of the OPB_LAREGISTER device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void OPB_LAREGISTER_Intr_DefaultHandler(void * baseaddr_p);

#endif // OPB_LAREGISTER_H
